#include <Wire.h>
#include <ds3231.h>
#include "RTClib.h"
#include "Adafruit_MCP23008.h"

Adafruit_MCP23008 mcp1, mcp2, mcp3, mcp4;

RTC_DS3231 rtc;

DateTime now;

struct ts clock;

int count = 0;
const long TEMPO_LAMPEGGIO = 1000;  //Tempo lampeggio del punto su secondo display


//********************************************************** S E T U P **********************************************************
void setup() {
  Serial.begin(9600);
  rtc.begin();
  //rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));

  DS3231_init(DS3231_CONTROL_INTCN);

  mcp1.begin(0x20);
  mcpPinMode(mcp1);

  mcp2.begin(0x21);
  mcpPinMode(mcp2);

  mcp3.begin(0x22);
  mcpPinMode(mcp3);

  mcp4.begin(0x23);
  mcpPinMode(mcp4);

  Test_Display();
}


//*********************************************************** L O O P ***********************************************************
void loop()
{
  if (rtc.lostPower()) 
  {
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
  }
  
  
  now = rtc.now();            //lettura dell'ora aggiornata
  clock.min = now.minute();   //esporto i minuti
  clock.hour = now.hour();    //esportole ore
  clock.sec = now.second();   //esporto i secondi

  DS3231_set(clock);
  //Dati visualizzati su seriale come debug
  Serial.print("ora: ");
  Serial.print(clock.hour);
  Serial.print(" : ");
  Serial.print(clock.min);
  Serial.print(" : ");
  Serial.print(clock.sec);
  Serial.print("\n");

  LedAcceso(decine(clock.hour), mcp1);//visulizzo le decine dell'ora
  LedAcceso(unita(clock.hour), mcp2); //visualizzo le unità dell'ora
  LedAcceso(decine(clock.min), mcp3); //visulizzo le decine dei minuti
  LedAcceso(unita(clock.min), mcp4);  //visualizzo le unità dei minuti
  punto_lampeggiante(mcp2,TEMPO_LAMPEGGIO);      //faccio lampeggiare il punto del secondo display ogni secondo

  delay(200);
}


//********************************************************** T E S T _ D I S P L A Y **********************************************************
//Accende in sequenza i numeri da 0 a 9, incluso il punto del display per testare il display e la comunicazione I2C
void Test_Display()
{
  punto(mcp1,HIGH); 
  punto(mcp2,HIGH); 
  punto(mcp3,HIGH); 
  punto(mcp4,HIGH); 
  for(int i=0;i<10;i++)
  {
    LedAcceso(i, mcp1); //ore decine
    LedAcceso(i, mcp2); //ore unità  
    LedAcceso(i, mcp3); //minuti decine
    LedAcceso(i, mcp4); //minuti unità    
    delay(500);
  }   
  LedAcceso(10, mcp1); //ore decine
  LedAcceso(10, mcp2); //ore unità  
  LedAcceso(10, mcp3); //minuti decine
  LedAcceso(10, mcp4); //minuti unità
  delay(1000);
}
