#include<Wire.h>
#include "Adafruit_MCP23008.h"

Adafruit_MCP23008 mcp1;
Adafruit_MCP23008 mcp2;
Adafruit_MCP23008 mcp3;
Adafruit_MCP23008 mcp4;

const int UP = 6;
const int DOWN = 7;

int ValConteggio = 0;
const int ValConteggio_MAX = 99;
const int ValConteggio_MIN = 0;


//********************************************************** S E T U P **********************************************************
void setup() 
{
  Serial.begin(9600);
  
  pinMode(UP, INPUT_PULLUP);
  pinMode(DOWN, INPUT_PULLUP);

  mcp1.begin(0x20);
  mcp1.pinMode(0, OUTPUT);
  mcp1.pinMode(1, OUTPUT);
  mcp1.pinMode(2, OUTPUT);
  mcp1.pinMode(3, OUTPUT);
  mcp1.pinMode(4, OUTPUT);
  mcp1.pinMode(5, OUTPUT);
  mcp1.pinMode(6, OUTPUT);
  mcp1.pinMode(7, OUTPUT);

  mcp2.begin(0x21);
  mcp2.pinMode(0, OUTPUT);
  mcp2.pinMode(1, OUTPUT);
  mcp2.pinMode(2, OUTPUT);
  mcp2.pinMode(3, OUTPUT);
  mcp2.pinMode(4, OUTPUT);
  mcp2.pinMode(5, OUTPUT);
  mcp2.pinMode(6, OUTPUT);
  mcp2.pinMode(7, OUTPUT);

  mcp3.begin(0x22);
  mcp3.pinMode(0, OUTPUT);
  mcp3.pinMode(1, OUTPUT);
  mcp3.pinMode(2, OUTPUT);
  mcp3.pinMode(3, OUTPUT);
  mcp3.pinMode(4, OUTPUT);
  mcp3.pinMode(5, OUTPUT);
  mcp3.pinMode(6, OUTPUT);
  mcp3.pinMode(7, OUTPUT);

  mcp4.begin(0x23);
  mcp4.pinMode(0, OUTPUT);
  mcp4.pinMode(1, OUTPUT);
  mcp4.pinMode(2, OUTPUT);
  mcp4.pinMode(3, OUTPUT);
  mcp4.pinMode(4, OUTPUT);
  mcp4.pinMode(5, OUTPUT);
  mcp4.pinMode(6, OUTPUT);
  mcp4.pinMode(7, OUTPUT);

  Test_Display();
  Visualizza_Display(ValConteggio);
}


//*********************************************************** L O O P ***********************************************************
void loop()
{
  char TipoConteggio = '0';

  while(digitalRead(UP)==LOW) TipoConteggio = '+';
  while(digitalRead(DOWN)==LOW) TipoConteggio = '-';
  //delay(200);
    
  switch (TipoConteggio)
  {
    case '+':
      if (ValConteggio == ValConteggio_MAX) ValConteggio = ValConteggio_MIN;
      else ValConteggio = ValConteggio + 1;  
      Visualizza_Display(ValConteggio);
      break;
      
    case '-':
      if (ValConteggio == ValConteggio_MIN) ValConteggio = ValConteggio_MAX;
      else ValConteggio = ValConteggio - 1;
      Visualizza_Display(ValConteggio);
      break;
      
    default:
      break;
  }  
}


//********************************************************** T E S T _ D I S P L A Y **********************************************************
//Accende in sequenza i numeri da 0 a 9, incluso il punto del display per testare il display e la comunicazione I2C
void Test_Display()
{
  punto(mcp1,HIGH); 
  punto(mcp2,HIGH);  
  punto(mcp3,HIGH); 
  punto(mcp4,HIGH); 
  for(int i=0;i<10;i++)
  {
    LedAcceso(i, mcp1); 
    LedAcceso(i, mcp2);
    LedAcceso(i, mcp3); 
    LedAcceso(i, mcp4);     
    delay(500);
  }   
  LedAcceso(10, mcp1); 
  LedAcceso(10, mcp2);
  LedAcceso(10, mcp3); 
  LedAcceso(10, mcp4);
  delay(1000);
}

//********************************************************** V I S U A L I Z Z A _ D I S P L A Y **********************************************************
//Visualizza il contenuto della variabile numerica "val"
void Visualizza_Display(int val)
{
  LedAcceso(decine(val), mcp1);
  LedAcceso(unita(val), mcp2);
  delay(200);
}
